#include <stdio.h>
#include "xdisplay.h"
#include "printlj.h"

static char res_text[]    = { 27, 69};
static char unco_text[]   = { 27, 42, 98, 48, 77 };
static char reso1_text[]  = { 27, 42, 116 };
static char reso2_text[]  = { 'R' };
static char start_text[]  = { 27, 42, 114, 48, 65};
static char end_text[]    = { 27, 42, 114, 66};
static char graph1_text[] = { 27, 42, 98 };
static char graph2_text[] = { 87 };
static char ej_text[]     = { 12 };

#define RES_LEN 2
#define UNCO_LEN 5
#define RESO1_LEN 3
#define RESO2_LEN 1
#define START_LEN 5
#define END_LEN 4
#define GRAPH1_LEN 3
#define GRAPH2_LEN 1
#define EJ_LEN 1

/* Print a bitmap on a HP Laserjet or compatible */

void print_lj(char *name, int res, INT *buf, int width, int lines)
{
    FILE *fpo;
    char temp_str[80];
    register int cur_line;
    register int cur_word;
    INT val;

    fpo = fopen(name, "w");
    if(!fpo)
    {
        printf("### Error: Failed to create '%s' ###\n", name);
        exit(13);
    }
    fwrite(res_text, 1, RES_LEN, fpo);                  /* Drucker zurcksetzen */
    fwrite(unco_text, 1, UNCO_LEN, fpo);                /* Wir arbeiten uncodiert */
    fwrite(reso1_text, 1, RESO1_LEN, fpo);              /* Auflsung einstellen */
    sprintf(temp_str, "%d", res);
    fwrite(temp_str, 1, strlen(temp_str), fpo);
    fwrite(reso2_text, 1, RESO2_LEN, fpo);
    for(cur_line = 0; cur_line < lines; cur_line++)     /* Zeilen durchgehen */
    {
        fwrite(start_text, 1, START_LEN, fpo);              /* Graphik starten */
        fwrite(graph1_text, 1, GRAPH1_LEN, fpo);            /* Graphiklnge einstellen */
        sprintf(temp_str, "%d", width>>3);
        fwrite(temp_str, 1, strlen(temp_str), fpo);
        fwrite(graph2_text, 1, GRAPH2_LEN, fpo);
        for(cur_word=0; cur_word < (width >> 5); cur_word++)
         {
          val = *(buf + cur_line*(width >> 5) + cur_word);
          fputc((val >> 24) & 255, fpo);
          fputc((val >> 16) & 255, fpo);
          fputc((val >> 8) & 255, fpo);
          fputc(val & 255, fpo);
         }
        fwrite(end_text, 1, END_LEN, fpo);                  /* Graphik beenden */
    }

    fwrite(ej_text, 1, EJ_LEN, fpo);                    /* Seite auswerfen */
    fwrite(res_text, 1, RES_LEN, fpo);                  /* Drucker zurcksetzen */
    fclose(fpo);                                        /* fertig */
}
 
/* Determine maximal DPI such that a given size fits on A4 */

int maximize_dpi(int width, int height)
 {
  if((width <= 525) && (height <= 790))
     return(75);
  if((width <= 700) && (height <= 1050))
     return(100);
  if((width <= 1050) && (height <= 1580))
     return(150);
  return(300);
 }

